#! /usr/bin/perl

#####
#
# KJVInfo.pl
# MDJ 2022/04/11
#
# Given:
#   Running Verse Number
# Returns:
#   Book Abbreviation
#   Chapter Number
#   Verse Number
#
# To Run:
#   KJVInfo.pl
#
# ** WARNING **
# When saving perl scripts in
# Textpad, you should use
# the "Save As" command and
# change the Line Ending Box
# to "UNIX".
#
# Otherwise, you may get:
# /usr/bin/perl^M No such file
#   ( ^M = \r\n ).
#
#####

# Pre-setup
use 5.30.0;

# Perl's Database Interface Module
use DBI;

# Data Source Name
my $dsn = "dbi:mysql:dbname=KJVData";

# mysql Username
my $user = "mdavidjohnson";

# mysql Password
#my $password = 'intentionallyObfuscated';

# mysql Attributes
my %attr = (RaiseError => 1, PrintError => 0);

# Open the Database Connection
my $dbh = DBI->connect($dsn, $user, $password, \%attr)
  or die "failed to connect to MySQL database:DBI->errstr()";
  
print "\nStarting KJVInfo Run\n\n";

# Declare variables
my($runVersNum) = "";     # Running Verse Number
my($bkAbbrev) = "";       # Book Abbreviation
my($chapNum) = "";        # Chapter Number
my($versNum) = "";        # Verse Number
my(@Info) = ("", "", ""); # Information Array

# Get the input and convert as required

print "Enter the Running Verse Number: ";
$runVersNum = <STDIN>;
# Truncate to remove "\n"
chomp($runVersNum);
# Convert to numeric
$runVersNum = 0 + $runVersNum;

# Call the function
@Info = &findKJVInfo
  ($runVersNum);
  
# Break out the results
($bkAbbrev, $chapNum, $versNum) = @Info;

# Display the result
print "\n";
print "Book Abbreviation    = ".$bkAbbrev."\n";
print "Chapter Number       = ".$chapNum."\n";
print "Verse Number         = ".$versNum."\n";
print "Running Verse Number = ".$runVersNum."\n";

print "\nKJVInfo Run Finished\n\n";

# Close the Database Connection
$dbh->disconnect;
  
exit;

sub findKJVInfo
{
	# $RVN = Running Verse Number
	# $bkA = Book Abbreviation
	# $chN = Chapter Number
	# $vsN = Verse Number
	# @kjv = Information Array
	
	my($RVN) = @_;
	
	# Prepare the SELECT Query
	my $sth = $dbh->prepare 
	("SELECT BookAbbrev, ChapterNum, VerseNum 
	  FROM  verseList
	  WHERE RunVerseNum = '$RVN'")
	or die "prepare statement failed: $dbh->errstr()";
	  
	# Execute the SELECT query
	$sth->execute();
	
	# Get the result of the query
	my($bkA, $chN, $vsN) = $sth->fetchrow_array();
	my(@kjv) = ($bkA, $chN, $vsN);
	
	# Complete the query
	$sth->finish();

	return @kjv;
}

#####
#
# EOF
#
#####


